diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 8fd1a8ecb..6d59b85e5 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -283,7 +283,7 @@ public class Block
         }
     }
     
-    public boolean collidesWithEntity(Entity entity)
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z)
     {
         return true;
     }
@@ -820,6 +820,8 @@ public class Block
 
     public static final Block wool = new BlockWool("wool", 110).withHardness(0.8F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
+    public static final Block rope = new BlockRope("rope", 111).withHardness(0.0F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final Block brickClay = new Block("brick.clay", 120, Material.stone).withHardness(3.0F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -946,7 +948,7 @@ public class Block
     public static final Block mud = new BlockMud("mud", 225, Material.dirt, false).withHardness(0.6F)
             .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.GROWS_FLOWERS, BlockTags.GROWS_CACTI, BlockTags.GROWS_TREES, BlockTags.CAVES_CUT_THROUGH, BlockTags.GROWS_SUGAR_CANE);
     public static final Block mudBaked = new BlockMud("mud.baked", 226, Material.stone, true).withHardness(1.5F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.GROWS_FLOWERS, BlockTags.GROWS_CACTI, BlockTags.GROWS_TREES, BlockTags.CAVES_CUT_THROUGH, BlockTags.GROWS_SUGAR_CANE);
 
     public static final Block spongeDry = new BlockSponge("sponge.dry", 230, false).withHardness(0.6F)
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
@@ -1009,6 +1011,9 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
     public static final Block leavesCacao = new BlockLeavesCacao("leaves.cacao", 298).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.SHEARS_DO_SILK_TOUCH, BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
+    public static final Block leavesCaatinga = new BlockLeavesOak("leaves.caatinga", 299).withHardness(0.2F).withLightBlock(1).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.MINEABLE_BY_HOE, BlockTags.MINEABLE_BY_SWORD, BlockTags.MINEABLE_BY_SHEARS);
+
 
     public static final Block saplingOak = new BlockSaplingOak("sapling.oak", 310).withHardness(0.0F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
@@ -1151,11 +1156,11 @@ public class Block
     public static final Block leverCobbleStone = new BlockLever("lever.cobble.stone", 480).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
 
-    public static final Block pressureplateStone = new BlockPressurePlate("pressureplate.stone", 490, BlockPressurePlate.MobType.MOBS, Material.stone).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block pressureplateStone = new BlockPressurePlate("pressureplate.stone", 490, EntityLiving.class, Material.stone).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
-    public static final Block pressureplatePlanksOak = new BlockPressurePlate("pressureplate.planks.oak", 491, BlockPressurePlate.MobType.EVERYTHING, Material.wood).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block pressureplatePlanksOak = new BlockPressurePlate("pressureplate.planks.oak", 491, Entity.class, Material.wood).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
-    public static final Block pressureplateCobbleStone = new BlockPressurePlate("pressureplate.cobble.stone", 492, BlockPressurePlate.MobType.PLAYERS, Material.stone).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+    public static final Block pressureplateCobbleStone = new BlockPressurePlate("pressureplate.cobble.stone", 492, EntityPlayer.class, Material.stone).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final Block motionsensorIdle = new BlockMotionSensor("motionsensor.idle", 500, false).withHardness(2.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange().withImmovableFlagSet()
@@ -1199,6 +1204,8 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block trapdoorGlass = new BlockTrapDoor("trapdoor.glass", 572, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block trapdoorPlanksOakPainted = new BlockTrapDoorPainted("trapdoor.planks.oak.painted", 573, Material.wood).withHardness(3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_AXE);
 
     public static final Block tnt = new BlockTNT("tnt", 580).withHardness(0.0F);
 
@@ -1210,10 +1217,20 @@ public class Block
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block doorIronTop = new BlockDoor("door.iron.top", 593, Material.metal, true).withHardness(5F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block doorPlanksOakPaintedBottom = new BlockDoorPainted("door.planks.oak.painted.bottom", 594, Material.wood, false).withHardness(3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+    public static final Block doorPlanksOakPaintedTop = new BlockDoorPainted("door.planks.oak.painted.top", 595, Material.wood, true).withHardness(3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+    public static final Block doorGlassBottom = new BlockDoorGlass("door.glass.bottom", 596, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block doorGlassTop = new BlockDoorGlass("door.glass.top", 597, Material.glass, true).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block mesh = new BlockMesh("mesh", 600).withHardness(1.5F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-
+    public static final Block meshGold = new BlockMeshGold("mesh.gold", 601).withHardness(1F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    
     public static final Block bed = new BlockBed("bed", 610).withHardness(0.2F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
     public static final Block seat = new BlockSeat("seat", 611).withHardness(0.2F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
@@ -1224,6 +1241,10 @@ public class Block
 
     public static final Block fire = new BlockFire("fire", 630).withHardness(0.0F).withLightEmission(1.0F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block brazierInactive = new BlockBrazier("brazier.inactive", 631, false).withHardness(1.5F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block brazierActive = new BlockBrazier("brazier.active", 632, true).withHardness(1.5F).withLightEmission(1.0F)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block mobspawner = new BlockMobSpawner("mobspawner", 640).withHardness(5F).withDisabledStats().withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block mobspawnerDeactivated = new BlockMobSpawnerDeactivated("mobspawner.deactivated", 641, Material.stone).withHardness(5F).withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -1406,6 +1427,9 @@ public class Block
         Item.itemsList[chestPlanksOakPainted.id] = new ItemBlockPainted(chestPlanksOakPainted, true);
         Item.itemsList[fencePlanksOakPainted.id] = new ItemBlockPainted(fencePlanksOakPainted, false);
         Item.itemsList[fencegatePlanksOakPainted.id] = new ItemBlockPainted(fencegatePlanksOakPainted, true);
+        Item.itemsList[doorPlanksOakPaintedBottom.id] = new ItemBlockPainted(doorPlanksOakPaintedBottom, true);
+        Item.itemsList[doorPlanksOakPaintedTop.id] = new ItemBlockPainted(doorPlanksOakPaintedTop, true);
+        Item.itemsList[trapdoorPlanksOakPainted.id] = new ItemBlockPainted(trapdoorPlanksOakPainted, true);
         Item.itemsList[lampIdle.id] = new ItemBlockLamp(lampIdle);
         Item.itemsList[algae.id] = new ItemBlockAlgae(algae);
         Item.itemsList[chestLegacy.id] = new ItemBlockChestLegacy(chestLegacy);
diff --git a/src/main/java/net/minecraft/core/block/BlockBrazier.java b/src/main/java/net/minecraft/core/block/BlockBrazier.java
new file mode 100644
index 000000000..33ceaedab
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockBrazier.java
@@ -0,0 +1,87 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemFirestriker;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class BlockBrazier
+    extends Block {
+    private final boolean burning;
+
+    public BlockBrazier(String key, int id, boolean burning) {
+        super(key, id, Material.metal);
+        this.burning = burning;
+    }
+
+    public boolean isBurning() {
+        return burning;
+    }
+
+    @Override
+    public boolean renderAsNormalBlock() {
+        return false;
+    }
+
+    @Override
+    public boolean isSolidRender() {
+        return false;
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+        return new ItemStack[] { new ItemStack(Block.brazierInactive, 1) };
+    }
+
+    @Override
+    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player) {
+        ItemStack heldItem = player.getHeldItem();
+        if (heldItem != null && heldItem.getItem() instanceof ItemFirestriker && !burning) {
+            if (world.getBlock(x + 1, y, z) instanceof BlockFluid ||
+                world.getBlock(x - 1, y, z) instanceof BlockFluid ||
+                world.getBlock(x, y, z + 1) instanceof BlockFluid ||
+                world.getBlock(x, y, z - 1) instanceof BlockFluid) {
+                return false;
+            }
+            world.setBlockAndMetadataWithNotify(x, y, z, Block.brazierActive.id, 0);
+            heldItem.damageItem(1, player);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
+            return true;
+        }
+        if (heldItem == null && burning) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Block.brazierInactive.id, 0);
+            return true;
+        }
+
+        return false;
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        if (burning) {
+            Block.fire.onBlockRemoved(world, x, y, z, data);
+        }
+    }
+
+    @Override
+    public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if (!burning) return;
+        Block block = Block.blocksList[blockId];
+        if (block instanceof BlockFluid) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Block.brazierInactive.id, 0);
+        }
+    }
+
+    @Override
+    public void randomDisplayTick(World world, int x, int y, int z, Random rand) {
+        if (burning) {
+            Block.fire.randomDisplayTick(world, x, y, z, rand);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockDoorGlass.java b/src/main/java/net/minecraft/core/block/BlockDoorGlass.java
new file mode 100644
index 000000000..00d806ce7
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockDoorGlass.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockDoorGlass extends BlockDoor {
+    public BlockDoorGlass(String key, int id, Material material, boolean isTop) {
+        super(key, id, material, isTop);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    {
+        return new ItemStack[] { new ItemStack(Item.doorGlass) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockDoorPainted.java b/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
new file mode 100644
index 000000000..66e934b30
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockDoorPainted.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockDoorPainted extends BlockDoor{
+    public BlockDoorPainted(String key, int id, Material material, boolean isTop) {
+        super(key, id, material, isTop);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    {
+        return new ItemStack[] { new ItemStack(Item.doorOakPainted, 1, 15 - (meta >> 4 & 0xF)) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockMesh.java b/src/main/java/net/minecraft/core/block/BlockMesh.java
index 1816d6534..03307b030 100644
--- a/src/main/java/net/minecraft/core/block/BlockMesh.java
+++ b/src/main/java/net/minecraft/core/block/BlockMesh.java
@@ -6,6 +6,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.world.World;
 
 public class BlockMesh extends BlockTransparent
 {
@@ -28,7 +29,7 @@ public class BlockMesh extends BlockTransparent
     }
 
     @Override
-    public boolean collidesWithEntity(Entity entity) {
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         return !(entity instanceof EntityItem);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockMeshGold.java b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
new file mode 100644
index 000000000..8241f1ad1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BlockMeshGold.java
@@ -0,0 +1,73 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityMeshGold;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class BlockMeshGold extends BlockTileEntity{
+    public BlockMeshGold(String key, int id) {
+        super(key, id, Material.metal);
+    }
+
+    @Override
+    protected TileEntity getNewBlockEntity() {
+        return new TileEntityMeshGold();
+    }
+    @Override
+    public boolean isSolidRender()
+    {
+        return false;
+    }
+    @Override
+    public boolean renderAsNormalBlock()
+    {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceOnSurface()
+    {
+        return true;
+    }
+    @Override
+    public boolean blockActivated(World world, int x, int y, int z, EntityPlayer player)
+    {
+        TileEntityMeshGold meshGold = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+        ItemStack heldItem = player.getHeldItem();
+        boolean flag = meshGold.setFilterItem(player, heldItem);
+        if(heldItem != null && heldItem.stackSize <= 0)
+        {
+            player.inventory.setInventorySlotContents(player.inventory.currentItem, null);
+        }
+        return flag;
+    }
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data) {
+        TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+        if (mesh.filterItem != null){
+            EntityItem item = world.dropItem(x, y, z, mesh.filterItem);
+            item.xd *= 0.5;
+            item.yd *= 0.5;
+            item.zd *= 0.5;
+            item.delayBeforeCanPickup = 0;
+        }
+        super.onBlockRemoved(world, x, y, z, data);
+    }
+
+    @Override
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
+        if (entity instanceof EntityItem){
+            TileEntityMeshGold mesh = (TileEntityMeshGold) world.getBlockTileEntity(x, y, z);
+            if (mesh.filterItem == null) return true;
+
+            ItemStack entityStack = ((EntityItem) entity).item;
+            return !entityStack.isItemEqual(mesh.filterItem);
+        }
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
index 2e6bd5b96..77f5efeda 100644
--- a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
@@ -45,7 +45,7 @@ public class BlockMobSpawner extends BlockTileEntity
     }
 
     @Override
-    public boolean collidesWithEntity(Entity entity) {
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         return !(entity instanceof EntityItem);
     }
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java b/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
index 235e0e0dc..c940c70c5 100644
--- a/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
+++ b/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
@@ -27,7 +27,7 @@ public class BlockMobSpawnerDeactivated extends BlockTransparent{
     }
 
     @Override
-    public boolean collidesWithEntity(Entity entity) {
+    public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
         return !(entity instanceof EntityItem);
     }
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockMud.java b/src/main/java/net/minecraft/core/block/BlockMud.java
index f5cdf0211..142598a1c 100644
--- a/src/main/java/net/minecraft/core/block/BlockMud.java
+++ b/src/main/java/net/minecraft/core/block/BlockMud.java
@@ -22,7 +22,7 @@ public class BlockMud extends Block{
     @Override
     public int tickRate()
     {
-        return 20;
+        return 5;
     }
 
     @Override
@@ -77,8 +77,8 @@ public class BlockMud extends Block{
         if(isWaterNearby(world, x, y, z, 1))
             return true;
 
-        // If there's water 4 blocks...
-        if(isWaterNearby(world, x, y, z, 4)){
+        // If there's water 3 blocks...
+        if(isWaterNearby(world, x, y, z, 3)){
             for (int x1 = x - 1; x1 <= x + 1; x1++)
             {
                 for (int y1 = y - 1; y1 <= y + 1; y1++)
@@ -166,8 +166,8 @@ public class BlockMud extends Block{
         // dry out mud
         if(isHardened) {
             if(!isLavaNearby(world, x, y, z)) {
-                if (canBecomeWet(world, x, y, z) || world.canBlockBeRainedOn(x, y + 1, z)) {
-                    world.setBlockWithNotify(x, y, z, Block.mud.id);
+                if (canBecomeWet(world, x, y, z)) {
+                    world.setBlock(x, y, z, Block.mud.id);
                 }
             }
         }
@@ -179,7 +179,7 @@ public class BlockMud extends Block{
                 {
                     world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D);
                 }
-                world.setBlockWithNotify(x, y, z, Block.mudBaked.id);
+                world.setBlock(x, y, z, Block.mudBaked.id);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
index 718229033..d7524bc80 100644
--- a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
@@ -1,33 +1,29 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.List;
 import java.util.Random;
 
 public class BlockPressurePlate extends Block
 {
-    private final MobType triggerMobType;
+    private final Class<? extends Entity> triggerMobClass;
 
-    public enum MobType
-    {
-        EVERYTHING,
-        MOBS,
-        PLAYERS
-    }
-
-	public BlockPressurePlate(String key, int id, MobType mobType, Material material)
+	public BlockPressurePlate(String key, int id, Class<? extends Entity> mobType, Material material)
     {
         super(key, id, material);
-        triggerMobType = mobType;
+        triggerMobClass = mobType;
         setTicking(true);
         float pixel = 1 / 16f;
         setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, pixel / 2, 1.0F - pixel);
@@ -60,13 +56,13 @@ public class BlockPressurePlate extends Block
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) || world.isBlockNormalCube(x, y + 1, z);
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        boolean flag = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        boolean flag = !canPlaceBlockAt(world, x, y, z);
         if(flag)
         {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
@@ -81,7 +77,7 @@ public class BlockPressurePlate extends Block
         {
             return;
         }
-        if (world.getBlockMetadata(x, y, z) != 0) {
+        if (isPressed(world.getBlockMetadata(x, y, z))) {
             updateState(world, x, y, z);
         }
     }
@@ -93,46 +89,36 @@ public class BlockPressurePlate extends Block
         {
             return;
         }
-        if (world.getBlockMetadata(x, y, z) != 1) {
+        if (!isPressed(world.getBlockMetadata(x, y, z))) {
             updateState(world, x, y, z);
         }
     }
 
     private void updateState(World world, int x, int y, int z)
     {
-        boolean isPressed = world.getBlockMetadata(x, y, z) == 1;
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPressed = isPressed(meta);
+        boolean isCeiling = (meta & 0b10) != 0;
         boolean isSteppedOn = false;
         float f = 0.125F;
-        List<Entity> list = null;
-        if(triggerMobType == MobType.EVERYTHING)
-        {
-            list = world.getEntitiesWithinAABBExcludingEntity(null, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(triggerMobType == MobType.MOBS)
-        {
-            list = world.getEntitiesWithinAABB(EntityLiving.class, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(triggerMobType == MobType.PLAYERS)
-        {
-            list = world.getEntitiesWithinAABB(EntityPlayer.class, AABB.getBoundingBoxFromPool((float)x + f, y, (float)z + f, (float)(x + 1) - f, (double)y + 0.25D, (float)(z + 1) - f));
-        }
-        if(list != null && list.size() > 0)
+        List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getBoundingBoxFromPool((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
+        if(list != null && !list.isEmpty())
         {
             isSteppedOn = true;
         }
         if(isSteppedOn && !isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, 1);
+            world.setBlockMetadataWithNotify(x, y, z, meta | 0b01);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.6F);
         }
         if(!isSteppedOn && isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, 0);
+            world.setBlockMetadataWithNotify(x, y, z, meta & 0b10);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.1D, (double)z + 0.5D, "random.click", 0.3F, 0.5F);
         }
@@ -145,10 +131,11 @@ public class BlockPressurePlate extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        if(data > 0)
+        boolean isCeiling = (world.getBlockMetadata(x, y, z) & 0b10) != 0;
+        if(isPressed(data))
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
         }
         super.onBlockRemoved(world, x, y, z, data);
     }
@@ -156,14 +143,24 @@ public class BlockPressurePlate extends Block
     @Override
     public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
     {
-        boolean isPressed = world.getBlockMetadata(x, y, z) == 1;
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPressed = isPressed(meta);
+        boolean isCeiling = (meta & 0b10) != 0;
         float pixel = 0.0625F;
         if(isPressed)
         {
-            setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
+            if (isCeiling){
+                setBlockBounds(pixel, 1f - 0.03125F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            } else {
+                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
+            }
         } else
         {
-            setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
+            if (isCeiling){
+                setBlockBounds(pixel, 1f - 0.0625F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            } else {
+                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
+            }
         }
     }
 
@@ -171,20 +168,25 @@ public class BlockPressurePlate extends Block
     public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
     {
 
-        return blockAccess.getBlockMetadata(x, y, z) > 0;
+        return isPressed(blockAccess.getBlockMetadata(x, y, z));
     }
 
     @Override
     public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
     {
-        if(world.getBlockMetadata(x, y, z) == 0)
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isCeiling = (meta & 0b10) != 0;
+        if(isPressed(world.getBlockMetadata(x, y, z)))
         {
-            return false;
+            return side == (isCeiling ? 0 : 1);
         } else
         {
-            return side == 1;
+            return false;
         }
     }
+    public boolean isPressed(int meta){
+        return (meta & 0b1) != 0;
+    }
 
     @Override
     public boolean canProvidePower()
@@ -197,4 +199,10 @@ public class BlockPressurePlate extends Block
     {
         return 1;
     }
+    @Override
+    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && sideHeight > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
+            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b10);
+        }
+    }
 }
